/*
 * File name: cma_mod.h
 *
 * Description: CMA utility module to allow device user access and CMA
 *
 * Copyright (C) 2013 Texas Instruments, Incorporated
 * Author: Aurelien Jacquiot <a-jacquiot@ti.com>
 * 
 * Some code borrowed from Linux virtio_udma driver
 * Copyright (C) 2012, 2013 Texas Instruments Incorporated
 * Author: Cyril Chemparathy <cyril@ti.com>
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation version 2.
 *
 * This program is distributed "as is" WITHOUT ANY WARRANTY of any kind,
 * whether express or implied; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */
#ifndef __CMA_MOD_H__
#define __CMA_MOD_H__

#define CMA_MOD_DEVNAME			"cma"

#define CMA_MOD_IOCMAGIC		0xfe

/* Memory types supported */
#define CMA_MOD_MEM_TYPE_MSM		1
#define CMA_MOD_MEM_TYPE_DDR		2

struct cma_mod_alloc
{
    unsigned int	mem_type; /* input arg */
    unsigned int	size;	  /* input arg */
    unsigned long	addr;	  /* output arg */
};

struct cma_mod_getinfo
{
    unsigned int	mem_type; /* input arg */
    unsigned int	size;	  /* output arg */
    unsigned long	addr;	  /* output arg */
};

struct cma_mod_init
{
    unsigned int	ddr_size; /* input arg */
    unsigned long	msm_addr; /* input arg */
    unsigned int	msm_size; /* input arg */
};

/* Supported ioctl cmds for the driver */
#define CMA_MOD_IOC_INIT	_IO(CMA_MOD_IOCMAGIC, 1)
#define CMA_MOD_IOC_GETINFO	_IOWR(CMA_MOD_IOCMAGIC, 2, struct cma_mod_getinfo*)
#define CMA_MOD_IOC_ALLOC	_IOWR(CMA_MOD_IOCMAGIC, 3, struct cma_mod_alloc*)
#define CMA_MOD_IOC_ENABLEPMU	_IO(CMA_MOD_IOCMAGIC,   4)

#endif /*__CMA_MOD_H__ */
