/*
 * File name: em_mod.h
 *
 * Description: OpenEM utility module to allow device user access 
 *
 * Copyright (C) 2013 Texas Instruments, Incorporated
 * Author: Aurelien Jacquiot <a-jacquiot@ti.com>
 * 
 * Some code borrowed from Linux virtio_udma driver
 * Copyright (C) 2012, 2013 Texas Instruments Incorporated
 * Author: Cyril Chemparathy <cyril@ti.com>
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation version 2.
 *
 * This program is distributed "as is" WITHOUT ANY WARRANTY of any kind,
 * whether express or implied; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */
#ifndef __EM_MOD_H__
#define __EM_MOD_H__

struct ti_em_intd_irq_config {
	int channel_base;
	int intd;
	unsigned queue;
};

#define EM_MOD_DEVNAME        "openem"

#define EM_IOC_MAGIC	      'O'
#define EM_IOC_WAITEVENT      _IO(EM_IOC_MAGIC, 2)
#define EM_IOC_WAITEVENTINIT  _IOWR(EM_IOC_MAGIC, 3, struct ti_em_intd_irq_config)
#define EM_IOC_WAITEVENTFREE  _IO(EM_IOC_MAGIC, 4)

#endif /*__EM_MOD_H__*/
