#!/usr/bin/perl
=pod

 Copyright 2014 Nokia Solutions and Networks
 All rights reserved.

 @file test_cpld_usr.pl
 @par REVISIONS
 <pre>
 Date       CoreID    SRID       Description
 ---------- --------- ---------- ---------------------------------------------
 09/05/14   kapusta              Initial Version
 
=cut

require 'test_tb.pl';

sub test_cpld_usr {
    test_start('cpld_usr');
    
    test_classExists('cpld-usr');
    test_deviceInClassExists('cpld-usr', 'cpld-usr');
    test_driverExistsInBus('fzm-cpld','spi');
   
    
    my $nodes_path = '/sys/class/cpld-usr/cpld-usr/';
    
    foreach my $i (1..8) {
        test_nodeReadWrite($nodes_path . "scr$i");
    }
    
    my @rw_nodes = ('bh_phy2_reset','bh_phy_reset','gps_power','next_reset','pse_reset','sfpc','sjmpr','wdc_period');
    my @read_nodes = ('fpga_reset','nmi');
    my @led_nodes = ('bh_led','off_led','rf_led','st_led');

    foreach my $rw_node (@rw_nodes) {
        test_nodeReadWrite($nodes_path . $rw_node);
    }
    
    foreach my $r_node (@read_nodes) {
        test_nodeRead($nodes_path . $r_node);
    }
    
    foreach my $led (@led_nodes) {
        test_nodeRead($nodes_path . $led);
        foreach my $color ('o','r','g','y') {
            test_nodeWriteValue($nodes_path.$led, $color);
            test_nodeWriteValue($nodes_path.$led, $color.'b');
        }
    }

    test_nodeRead("/proc/cpld-usr");
    
    return test_finish();
}
1;

